<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template #page-content>
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <!-- For each plot, display the soil information -->
          <q-card-section
            v-if="loading"
            class="text-center"
          >
            <q-spinner-dots
              size="40px"
              color="primary"
            />
          </q-card-section>
          <template v-else>
            <q-card-section class="text-caption text-grey q-pb-none">
              <translate>
                Values have been calculated based on your own soil samples and public data.
              </translate>
            </q-card-section>
            <q-card-section
              v-for="(soilObject, index) in $store.state.fertilizationPlan.parameters.soil_objects"
              :key="index"
            >
              <div class="text-subtitle1 q-mb-sm">
                <span class="text-grey">
                  <translate>Plot</translate>:
                </span> {{ soilObject.plot.name }}
              </div>
              <q-select
                :model-value="soilObject.observations.texture.value"
                @update:model-value="value => onUpdateProperty(soilObject.plot, 'texture', value)"
                :display-value="soilObject.observations.texture.value ? soilObject.observations.texture.label: undefined"
                :options="soilTypes"
                :label="requiredSoilProperties.find(rsp => rsp.id === 'texture').label"
                filled
                class="q-mb-md"
              />
              <template v-if="$store.state.fertilizationPlan.parameters.strategy.value !== 'MAINTENANCE'">
                <q-input
                  :model-value="soilObject.observations.organic_matter_pct.value"
                  @update:model-value="value => updateOrganicMatter(value, soilObject.plot)"
                  filled
                  type="number"
                  :label="requiredSoilProperties.find(rsp => rsp.id === 'organic_matter_pct').label"
                  :suffix="requiredSoilProperties.find(rsp => rsp.id === 'organic_matter_pct').unit_of_measure.symbol"
                  :rules="rulesOM"
                  :min="organicMatterMin"
                  :max="organicMatterMax"
                  class="q-mb-none"
                />
                <q-input
                  :model-value="soilObject.observations.phosphorus.value"
                  @update:model-value="value => updateP(value, soilObject.plot)"
                  filled
                  type="number"
                  :label="requiredSoilProperties.find(rsp => rsp.id === 'phosphorus').label"
                  :suffix="requiredSoilProperties.find(rsp => rsp.id === 'phosphorus').unit_of_measure.symbol"
                  :rules="rulesPK"
                  :min="pMin"
                  :max="pMax"
                  class="q-mb-none"
                />
                <q-input
                  :model-value="soilObject.observations.potassium.value"
                  @update:model-value="value => updateK(value, soilObject.plot)"
                  filled
                  type="number"
                  :label="requiredSoilProperties.find(rsp => rsp.id === 'potassium').label"
                  :suffix="requiredSoilProperties.find(rsp => rsp.id === 'potassium').unit_of_measure.symbol"
                  :rules="rulesPK"
                  :min="kMin"
                  :max="kMax"
                  class="q-mb-none"
                />
              </template>
              <q-separator v-if="index < $store.state.fertilizationPlan.parameters.soil_objects.length-1" />
            </q-card-section>
          </template>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import FertilicalcMixin from 'src/pages/fieldbook/fertilization/algorithms/fertilicalc/mixins/FertilicalcMixin'

import querySoilDerivedObjectsByPlotId from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/querySoilDerivedObjectsByPlotId'

export default {
  name: 'FertilicalcSoilPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, FertilicalcMixin],
  data () {
    return {
      loading: false
    }
  },
  mounted () {
    this._mergeSoilObjects()
  },
  computed: {
    canContinue () {
      // texture is selected
      // if strategy is not maintenance, p and k are required
      const soilObjects = this.$store.state.fertilizationPlan.parameters.soil_objects
      if (soilObjects?.length) {
        for (let i = 0; i < soilObjects.length; i++) {
          if (soilObjects[i].observations.texture?.value == null) {
            // soil texture is required
            return false
          }
          if (this.$store.state.fertilizationPlan.parameters.strategy.value !== 'MAINTENANCE') {
            // p and k are required
            if (soilObjects[i].observations.phosphorus?.value == null || soilObjects[i].observations.potassium?.value == null) {
              return false
            }
          }
        }
        // is ok
        return true
      } else {
        return false
      }
    },
    pageTitle () {
      return this.$gettext('Soil information')
    },
    pageSubTitle () {
      return 'FertiliCalc'
    },
    rulesOM () {
      return [
        val => !!val || !isNaN(val) || this.$gettext('Value must be a number'),
        val => ((val <= 100) && (val >= 0)) || this.$gettext('Percentage must be between 0 and 100')
      ]
    },
    rulesPK () {
      return [
        val => val || val === 0 || `* ${this.$gettext('This field is required')}`,
        val => !!val || !isNaN(val) || this.$gettext('Value must be a number')
      ]
    }
  },
  methods: {
    async _mergeSoilObjects () {
      // Merge the soil information in the store with what we get from apollo
      this.loading = true
      const result = await this.$apollo.query({
        query: querySoilDerivedObjectsByPlotId,
        variables: {
          plot_id: this.$store.state.fertilizationPlan.target.id
        },
        fetchPolicy: 'network-only'
      })

      // Now we have all the data from the database about the plot/plot group
      // that we have requested
      // It might happen that some data is missing (no soil derived object for a
      // certain plot)
      const soilDerivedObjects = result.data.soil_derived_object

      // Build the list of plots that are necessary to be filled
      let soilObjects = [{
        plot: { ...this.$store.state.fertilizationPlan.target },
        observations: {}
      }]

      // Add the required inputs for each plot and pre-fill using either
      // the data in the store (priority) or the data from the database
      // or nothing (blank input)
      soilObjects = soilObjects.map(obj => {
        this.requiredSoilProperties.forEach(rsp => {
          // First look in the store
          const soilObjectFromStore = this.$store.state.fertilizationPlan.parameters.soil_objects &&
            this.$store.state.fertilizationPlan.parameters.soil_objects.find(so => so && so.plot && so.plot.id === obj.plot.id)
          const resultFromStore = soilObjectFromStore &&
            soilObjectFromStore.observations &&
            soilObjectFromStore.observations[rsp.id]

          if (resultFromStore && resultFromStore.value != null) {
            obj.observations[rsp.id] = { ...resultFromStore }
          } else {
            // If no value in the store, look into what we just received
            // from the database
            const soilObjectFromDatabase = soilDerivedObjects &&
              soilDerivedObjects.find(sdo => sdo && sdo.plot && sdo.plot.id === obj.plot.id)
            const soilDerivedObservationFromDatabase = soilObjectFromDatabase &&
              soilObjectFromDatabase.derived_observations.find(sdodo => sdodo.observable_property.id === rsp.id)
            const resultFromDatabase = soilDerivedObservationFromDatabase && soilDerivedObservationFromDatabase.result

            const textureSimplificationMapping = {
              SAND: 'SANDY',
              LOAMY_SAND: 'SANDY',
              SANDY_LOAM: 'SANDY_LOAM',
              LOAM: 'LOAM',
              SILTY_LOAM: 'SILTY_LOAM',
              SANDY_CLAY_LOAM: 'CLAY_LOAM',
              CLAY_LOAM: 'CLAY_LOAM',
              SILTY_CLAY_LOAM: 'CLAY_LOAM',
              SANDY_CLAY: 'CLAY',
              SILTY_CLAY: 'CLAY',
              CLAY: 'CLAY'
            }

            if (resultFromDatabase) {
              if (rsp.id === 'texture') {
                const soilType = this.soilTypes.find(st => st.value === textureSimplificationMapping[resultFromDatabase.value])
                obj.observations[rsp.id] = {
                  ...resultFromDatabase,
                  value: soilType?.value,
                  label: soilType?.label
                }
              } else {
                obj.observations[rsp.id] = {
                  ...resultFromDatabase,
                  value: Math.round(resultFromDatabase.value * 10) / 10
                }
              }
            } else {
              obj.observations[rsp.id] = { value: null }
            }
          }
        })
        return obj
      })

      this.updateParameter('soil_objects', soilObjects)
      this.loading = false
    },
    onUpdateProperty (plot, requiredPropertyId, value) {
      if (requiredPropertyId !== 'texture' && !isNaN(value)) value = parseFloat(value)
      const soilObjects = this.$store.state.fertilizationPlan.parameters.soil_objects ? JSON.parse(JSON.stringify(this.$store.state.fertilizationPlan.parameters.soil_objects)) : []
      let idxObject = soilObjects.findIndex(so => so && so.plot && so.plot.id === plot.id)
      if (idxObject === -1) {
        soilObjects.push({ plot, observations: {} })
        idxObject = soilObjects.length - 1
      }
      soilObjects[idxObject].observations = soilObjects[idxObject].observations || {}
      soilObjects[idxObject].observations[requiredPropertyId] = soilObjects[idxObject].observations[requiredPropertyId] || {}
      if (requiredPropertyId === 'texture') {
        soilObjects[idxObject].observations[requiredPropertyId] = value
      } else {
        soilObjects[idxObject].observations[requiredPropertyId].value = value
      }
      this.updateParameter('soil_objects', soilObjects)
    },
    onClickNext () {
      this.$router.push({
        name: 'fertilicalcNitrogen'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'fertilicalcStrategy'
      })
    },
    updateOrganicMatter (value, soilObjectPlot) {
      return this.onUpdateProperty(
        soilObjectPlot,
        'organic_matter_pct',
        value < this.organicMatterMin ? this.organicMatterMin : value > this.organicMatterMax ? this.organicMatterMax : value
      )
    },
    updateP (value, soilObjectPlot) {
      return this.onUpdateProperty(
        soilObjectPlot,
        'phosphorus',
        value < this.pMin ? this.pMin : value > this.pMax ? this.pMax : value
      )
    },
    updateK (value, soilObjectPlot) {
      return this.onUpdateProperty(
        soilObjectPlot,
        'potassium',
        value < this.kMin ? this.kMin : value > this.kMax ? this.kMax : value
      )
    }
  }
}
</script>
